Subject: Re: [Pana] NEW: [issue57] PSR retransmission strategy

From: Alper Yegin <[email-masked]>
Date: Tue, 10 Feb 2004 13:35:58 -0800

It is possible that both PAA and PaC initiate the discovery and
   initial handshake procedure at the same time, i.e., the PAA sends a
   PANA-Start-Request message while the PaC sends a PANA-PAA-Discover
   message.  To resolve the race condition, the PAA SHOULD silently
   discard the PANA-PAA-Discover message received from the PaC after it
   has sent a PANA-Start-Request message with creating a state for the
   PaC.

JARI: (Substantial) Since you said above that a PANA-Start-Request
      message is never retransmitted, what if this message is lost
      AND you at the same time silently discard all PANA-PAA-Discover
      messages? Seems like you would be stuck, or did I miss something?

Couldn't we solve this by simply PAA responding to PDI even if it already
sent an unsolicited PSR? Of course the PaC would know not to respond to all
PSRs it receives.

Alper

On 2/9/04 2:59 PM, "Yoshihiro Ohba" <[email-masked]> wrote:

> On Thu, Feb 05, 2004 at 11:41:51AM +0200, [email-masked] wrote:
>> New submission from Dan Forsberg <[email-masked]>:
>> 
>> From Jari Arkko:
>>>      - "PSR retransmission strategy"
>>> 
>>>        In Section 4.2 I also had a possible issue with retransmission
>>>        strategy in case PSR is lost. The document seems to say that
>>> PSRs are never retransmitted but at the same time the PDIs
>>> are silently discarded. This could lead to a deadlock.
>> 
>> Alper Yegin:
>> Another issue to open.
> 
> As Jari pointed out, I think the deadlock situation can occur.
> 
> There are two cases when a PSR is sent.
> 
> - A PSR is sent with creating a PANA session state.
> 
> This cases occurs when a Cookie AVP is not included in the PSR (i.e.,
> stateful discovery).  Since the PAA does create a state, the deadlock
> can occur if PAA discards PDI after sending the PSR.  I think that the
> PAA should retransmit the PSR in this case to avoid the deadlock.
> 
> - A PSR is sent without creating a PANA session state.
> 
> This cases occurs when a Cookie AVP is included in the PSR (i.e.,
> stateless discovery).  Since the PAA does not have a state, the
> deadlock cannot not occur.
> 
> What about PSA?  I think in the case where a PSR is retransmitted, the
> PSA does not need to be retransmitted.
> 
> 
> Suggested changes:
> 
> In section 4.2, change:
> 
>  "A PANA-Start-Request message is never retransmitted. A
>  PANA-Start-Answer message is retransmitted based on timer in the same
>  manner as other messages retransmitted at PANA-layer."
>                  
> to:
>                  
>  "If a PANA-Start-Request message is sent without carrying a Cookie
>  AVP, the PAA MUST retransmit the message.  Otherwise, if a
>  PANA-Start-Request message is sent with carrying a Cookie AVP, the
>  PAA MUST NOT retransmit the message.  On the other hand, if a
>  PANA-Start-Answer message is sent without carrying a Cookie AVP, the
>  PaC MUST NOT retransmit the message.  Otherwise, if a
>  PANA-Start-Answer message is sent with carrying
>  a Cookie AVP, the PaC MUST retransmit the message."
> 
> 
> Change the first paragraph of section 10 to:
> 
>  "The PANA protocol provides retransmissions for all the message
>  exchanges except PANA-Auth-Request/Answer. PANA-Auth-Request messages
>  carry EAP requests which are retransmitted by the EAP protocol
>  entities when needed. The messages that need PANA-level
>  retransmissions are listed below:
>                  
>        PANA-PAA-Discover (PDI)
>        PANA-Start-Request (PSR)*
>        PANA-Start-Answer (PSA)**
>        PANA-Bind-Request (PBR)
>        PANA-Reauth-Request (PRAR)
>        PANA-Termination-Request (PTR)
>   
>  *)  PSR that carries a Cookie AVP is not retransmitted.
>  **) PSA that does not carry a Cookie AVP is not retransmitted."
> 
> 
> Yoshihiro Ohba
> 
> _______________________________________________
> Pana mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/pana
> 

_______________________________________________
Pana mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/pana